package com.taais.biz.utils;

import java.util.Comparator;

public class NaturalOrderComparator implements Comparator<String> {
    @Override
    public int compare(String a, String b) {
        int ia = 0, ib = 0;
        while (ia < a.length() && ib < b.length()) {
            char ca = a.charAt(ia);
            char cb = b.charAt(ib);

            if (Character.isDigit(ca) && Character.isDigit(cb)) {
                int numA = 0, numB = 0;

                // 提取完整数字
                while (ia < a.length() && Character.isDigit(a.charAt(ia))) {
                    numA = numA * 10 + (a.charAt(ia++) - '0');
                }
                while (ib < b.length() && Character.isDigit(b.charAt(ib))) {
                    numB = numB * 10 + (b.charAt(ib++) - '0');
                }

                if (numA != numB) {
                    return Integer.compare(numA, numB);
                }
            } else {
                if (ca != cb) {
                    return Character.compare(ca, cb);
                }
                ia++;
                ib++;
            }
        }
        return Integer.compare(a.length(), b.length());
    }
}
